#ifndef __SOLVER_HPP__
#define __SOLVER_HPP__

#include "../dataparser/structures.hpp"
#include "../params.hpp"

template<typename L, typename D>
class Solver {
public:
  Solver(ProblemData<L,D>& pd, Parameters &par) : instance(pd), params(par) {
    deltaAlpha.resize(instance.n);

  }

  virtual ~Solver() {
  }

  virtual void solve(std::vector<D> &w, std::vector<D> &deltaW) { }

protected:
  ProblemData<L,D>& instance;
  Parameters& params;
  std::vector<D> deltaAlpha;

};


#endif // __SOLVER_HPP__

